"""
$Id: link_triple.py 27889 2006-01-26 23:15:28Z rmasse $
$URL: svn+ssh://svn.mems-exchange.org/repos/trunk/dulcinea/lib/link_triple.py $
"""

from dulcinea.common import get_publisher
from durus.persistent import Persistent
from qp.lib.spec import sequence, add_getters_and_setters
from qp.lib.spec import string

def get_link_triple_db():
    return get_publisher().get_link_triple_db()

class LinkTripleDatabase(Persistent):

    links_is = sequence(element_spec=(string, string, (string, None)),
                        container_spec=list)

    def __init__(self):
        self.links = []

    def __getitem__(self, index):
        return self.links[index]

    def __setitem__(self, index, link):
        self._p_note_change()
        self.links[index] = link

    def __delitem__(self, index):
        self._p_note_change()
        del self.links[index]

    def insert_link(self, link, index=None):
        self._p_note_change()
        if index is None:
            index = len(self.links)
        assert 0 <= index <= len(self.links), index
        links_after = self.links[index:]
        self.links = self.links[:index]
        self.links.append(link)
        self.links.extend(links_after)

add_getters_and_setters(LinkTripleDatabase)
