"""
$URL: svn+ssh://svn.mems-exchange.org/repos/trunk/dulcinea/lib/test/utest_user.py $
$Id: utest_user.py 27773 2006-01-03 15:25:25Z dbinger $
"""
from dulcinea.user import DulcineaUser as User
from sancho.utest import UTest, raises
from dulcinea.common import get_site_name

try:
    get_site_name()
except AssertionError:
    import os
    os.environ['SITE'] = 'test'
    get_site_name()

class DulcineaUserTest (UTest):

    def check_init (self):
        raises(TypeError, User, '!@#$%^')
        User('amk')
        u = User(None)
        u.set_id('foo')
        raises(AssertionError, User('foo').set_id, 'foo')
        raises(TypeError, User(None).set_id, '!foo')
        u = User(None)
        assert u.id == None
        u.set_id('foo')
        assert u.id == "foo"
        raises(AssertionError, u.set_id, 'bar')

    def check_password (self):
        user = User('foo')
        user.set_password("biteme")
        assert user.has_password("biteme")
        assert not user.has_password("dontbiteme")
        password1 = user.generate_password()
        assert user.has_password(password1)
        password2 = user.generate_password()
        assert user.has_password(password2)
        assert password1 != password2


if __name__ == "__main__":
    DulcineaUserTest()
