from os.path import join, islink, samefile, isdir, exists
from os import listdir, symlink, makedirs
from qpy.compile import compile_qpy_files
import dulcinea

def build_ui_mirror(path_from_dulcinea):
    assert path_from_dulcinea.startswith('/uiqp')
    dulcinea_path = dulcinea.__path__[0]
    relative_uiqp = path_from_dulcinea
    relative_ui = '/ui' + relative_uiqp[5:]
    for name in listdir(dulcinea_path + relative_ui):
        if name.endswith('~'):
            continue
        if name.endswith('.pyc'):
            continue
        if name.endswith('.pyo'):
            continue
        if name.startswith('.'):
            continue
        if path_from_dulcinea == '/uiqp' and name.startswith('__init__.py'):
            continue
        src = join(dulcinea_path + relative_ui, name)
        if name.endswith('.ptl'):
            dst = join(dulcinea_path + relative_uiqp, name[:-4] + '.qpy')
        else:
            dst = join(dulcinea_path + relative_uiqp, name)
        if islink(dst):
            assert samefile(dst, src), (src, dst)
        elif isdir(src):
            if not exists(dst):
                makedirs(dst)
        else:
            try:
                symlink(src, dst)
            except OSError:
                print (src, dst)
                raise
    compile_qpy_files(dulcinea_path + relative_uiqp)

build_ui_mirror('/uiqp')
build_ui_mirror('/uiqp/lib')
build_ui_mirror('/uiqp/user')
build_ui_mirror('/uiqp/form2')
build_ui_mirror('/uiqp/test')

